#include <windows.h>
#include <commctrl.h>
#include "CToolTip.h"

CToolTip::CToolTip(void){
	hWnd = NULL;
	hInst = NULL;
}

CToolTip::~CToolTip(void){
	if(hWnd != NULL){
		PostMessage(hWnd,WM_DESTROY,0,0);
		hWnd = NULL;
	}
}
void CToolTip::Activate(BOOL fActivate){
	SendMessage(hWnd,TTM_ACTIVATE ,(WPARAM)fActivate,(LPARAM)0);  
};

BOOL CToolTip::AddTool(LPTOOLINFO lpti){
	return SendMessage(hWnd,TTM_ADDTOOL  ,(WPARAM)0,(LPARAM)lpti);  
};

//BOOL CToolTip::AdjustRect(BOOL fLarger,LPRECT prc){
//	return SendMessage(hWnd,TTM_ADJUSTRECT ,(WPARAM)fLarger,(LPARAM)prc);  
//};

void CToolTip::DelTool(LPTOOLINFO lpti){
	SendMessage(hWnd,TTM_DELTOOL,(WPARAM)0,(LPARAM)lpti);  
};

BOOL CToolTip::EnumTools(UINT iTool,LPTOOLINFO lpti){
	return SendMessage(hWnd,TTM_ENUMTOOLS ,(WPARAM)iTool,(LPARAM)lpti);  
};

//DWORD CToolTip::GetBubbleSize(LPTOOLINFO pTtm){
//	return SendMessage(hWnd,TTM_GETBUBBLESIZE ,(WPARAM)0,(LPARAM)pTtm);  
//};

BOOL CToolTip::GetCurrentTool(LPTOOLINFO lpti){
	return SendMessage(hWnd,TTM_GETCURRENTTOOL ,(WPARAM)0,(LPARAM)lpti);  
};

int CToolTip::GetDelayTime(DWORD dwDuration){
	return SendMessage(hWnd,TTM_GETDELAYTIME ,(WPARAM)dwDuration,(LPARAM)0);  
};

void CToolTip::GetMargin(LPRECT lprc){
	SendMessage(hWnd,TTM_GETMARGIN ,(WPARAM)0,(LPARAM)lprc);  
};

int CToolTip::GetMaxTipWidth(void){
	return SendMessage(hWnd,TTM_GETMAXTIPWIDTH ,(WPARAM)0,(LPARAM)0);  
};

void CToolTip::GetText(LPTOOLINFO lpti){
	SendMessage(hWnd,TTM_GETTEXT ,(WPARAM)0,(LPARAM)lpti);  
};

COLORREF CToolTip::GetTipBkColor(void){
	return SendMessage(hWnd,TTM_GETTIPBKCOLOR ,(WPARAM)0,(LPARAM)0);  
};

COLORREF CToolTip::GetTipTextColor(void){
	return SendMessage(hWnd,TTM_GETTIPTEXTCOLOR ,(WPARAM)0,(LPARAM)0);  
};

//void CToolTip::GetTitle(PTTGETTITLE pTTGetTitle){
//	SendMessage(hWnd,TTM_GETTITLE ,(WPARAM)0,(LPARAM)pTTGetTitle);  
//};

DWORD CToolTip::GetColoCount(void){
	return SendMessage(hWnd,TTM_GETTOOLCOUNT ,(WPARAM)0,(LPARAM)0);  
};

BOOL CToolTip::GetToolInfo(LPTOOLINFO lpti){
	return SendMessage(hWnd,TTM_GETTOOLINFO ,(WPARAM)0,(LPARAM)lpti);  
}

BOOL CToolTip::HitTest(LPHITTESTINFO lphti){
	return SendMessage(hWnd,TTM_HITTEST ,(WPARAM)0,(LPARAM)lphti);  
};

void CToolTip::NewToolRect(LPTOOLINFO lpti){
	SendMessage(hWnd,TTM_NEWTOOLRECT ,(WPARAM)0,(LPARAM)lpti);  
};

void CToolTip::Pop(void){
	SendMessage(hWnd,TTM_POP,(WPARAM)0,(LPARAM)0);  
};

//void CToolTip::Popup(void){
//	SendMessage(hWnd,TTM_POPUP ,(WPARAM)0,(LPARAM)0);  
//};

void CToolTip::RelayEvent(LPMSG lpmsg){
	SendMessage(hWnd,TTM_RELAYEVENT ,(WPARAM)0,(LPARAM)lpmsg);  
};

void CToolTip::SetDelayTime(DWORD iType,int iTime){
	SendMessage(hWnd,TTM_SETDELAYTIME ,(WPARAM)iType,(LPARAM)MAKELONG(iTime,0));  
};

void CToolTip::SetMargin(LPRECT lprc){
	SendMessage(hWnd,TTM_SETMARGIN ,(WPARAM)0,(LPARAM)lprc);  
};


int CToolTip::SetMaxTipsWidth(int iWidth){
	return SendMessage(hWnd,TTM_SETMAXTIPWIDTH ,(WPARAM)0,(LPARAM)iWidth);  
};


void CToolTip::SetTipBkColor(COLORREF clr){
	SendMessage(hWnd,TTM_SETTIPBKCOLOR ,(WPARAM)clr,(LPARAM)0);  
};


void CToolTip::SetTipTextColor(COLORREF clr){
	SendMessage(hWnd,TTM_SETTIPTEXTCOLOR ,(WPARAM)clr,(LPARAM)0);  
};


//BOOL CToolTip::SetTitle(int icon,LPCTSTR pszTitle){
//	return SendMessage(hWnd,TTM_SETTITLE ,(WPARAM)icon,(LPARAM)pszTitle);  
//};

void CToolTip::SetToolInfo(LPTOOLINFO lpti){
	SendMessage(hWnd,TTM_SETTOOLINFO ,(WPARAM)0,(LPARAM)lpti);  
};

//void CToolTip::SetWindowTheme(LPWSTR pwStr){
//	SendMessage(hWnd,TTM_SETWINDOWTHEME ,(WPARAM)0,(LPARAM)pwStr);  
//};

void CToolTip::TrackActivate(BOOL bActivate,LPTOOLINFO lpti){
	SendMessage(hWnd,TTM_TRACKACTIVATE ,(WPARAM)bActivate,(LPARAM)lpti);  
}

void CToolTip::TrackPosition(int xPos, int yPos){
	SendMessage(hWnd,TTM_TRACKPOSITION ,(WPARAM)0,(LPARAM)MAKELONG(xPos, yPos));  
};

void CToolTip::Update(void){
	SendMessage(hWnd,TTM_UPDATE ,(WPARAM)0,(LPARAM)0);  
};

void CToolTip::UpdateTipText(LPTOOLINFO lpti){
	SendMessage(hWnd,TTM_UPDATETIPTEXT ,(WPARAM)0,(LPARAM)lpti);  
};

void CToolTip::WindowFromPoint(POINT FAR * lppt){
	SendMessage(hWnd,TTM_WINDOWFROMPOINT ,(WPARAM)0,(LPARAM)lppt);  
}


HWND CToolTip::Create(DWORD dwExStyle,DWORD dwStyle,
					int x,int y,int nWidth,int nHeight,
					HWND hwndParent,
					HMENU hmenu,
					HINSTANCE hinst,
					LPVOID lpvParam){

	hWnd = CreateWindowEx(dwExStyle,TOOLTIPS_CLASS,NULL,
		dwStyle,
		x,y,nWidth,nHeight,hwndParent,hmenu,hinst,lpvParam);

	hInst = hinst;
		
	return hWnd;
}